/******************************************************************
 *
 * Copyright (c) 2003 Benjamin `Quisar' Lerman.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions  
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *   
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 ******************************************************************/
%{
#include "assembler.tab.h"
%}

%%

PUSH			return TokPUSH;
DUP			return TokDUP;
SWAP			return TokSWAP;
DISCARD			return TokDISCARD;
ADD			return TokADD;
SUB			return TokSUB;
MUL			return TokMUL;
DIV			return TokDIV;
MOD			return TokMOD;
LABEL			return TokLABEL;
CALL			return TokCALL;
JUMP			return TokJUMP;
JUMPZ			return TokJUMPZ;
JUMPNEG			return TokJUMPNEG;
ENDSUB			return TokENDSUB;
END			return TokEND;
STORE			return TokSTORE;
RETR			return TokRETR;
OUTCHAR			return TokOUTCHAR;
OUTNUM			return TokOUTNUM;
INCHAR			return TokINCHAR;
INNUM			return TokINNUM;
[1-9][0-9]*		{ yylval = atoi(yytext); return TokPNUMBER; }
[0-9][0-9]*		{ yylval = atoi(yytext); return TokNUMBER; }
[+-][0-9][0-9]*		{ yylval = atoi(yytext); return TokNUMBER; }
#[^\n]*
[ \t\n]

%%
