/* $Id: lexer.l,v 1.4 2002/03/05 17:25:51 quisar Exp $ */
/******************************************************************
 *
 * Copyright (c) 2003 Benjamin `Quisar' Lerman.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions  
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *   
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 ******************************************************************/

%{
#include <string.h>

#include "programme.h"

#include "grammar.tab.h"
%}

%%
if	return bIF;
else	return bELSE;
while	return bWHILE;
for	return bFOR;
do	return bDO;
int	return bINT;
asm	return bASM;
return	return bRETURN;
getint	return bGETINT;
getchar return bGETCHAR;
outint	return bOUTINT;
outchar return bOUTCHAR;
malloc  return bMALLOC;
exit	return bEXIT;
.*	{ yylval.s = strdup(yytext); return bNAME; }

%%

int scanstring(char *s)
{
 int res;
 YY_BUFFER_STATE tmp;
 tmp = yy_scan_string(s);
 res = yylex();
 yy_delete_buffer(tmp);
 return res;
}
