/******************************************************************
 *
 * Copyright (c) 2003 Benjamin `Quisar' Lerman.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions  
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *   
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 ******************************************************************/

#ifndef _MACHINE_H_
#define _MACHINE_H_

#include <gmpxx.h>
#include <list>
#include <map>
#include <vector>
#include <cstdio>

#define PUSH		 0
#define DUP		 1
#define SWAP		 2
#define DISCARD		 3

#define ADD		 4
#define SUB		 5
#define MUL		 6
#define INTDIV		 7
#define MODULO		 8

#define CALL		 9
#define JUMP		10
#define JUMPZ		11
#define JUMPNEG		12
#define ENDSUB		13
#define END		14

#define STORE		15
#define RETR		16

#define OUTCHAR		17
#define OUTNUM		18
#define INCHAR		19
#define INNUM		20

typedef std::list<mpz_class> stack_t;
typedef std::map<mpz_class,mpz_class> mem_t;
typedef std::vector<std::pair<int, mpz_class> > instruction_t;
typedef std::map<mpz_class,int> labels_t;

extern instruction_t instruction;
extern labels_t labels;
extern FILE* file;

int yyparse(void);
void exec_prog(int deb);
void print_prog(void);

#endif
